---
title: RTCDtlsTransport
slug: Web/API/RTCDtlsTransport
tags:
  - API
  - Draft
  - Experimental
  - Interface
  - NeedsContent
  - NeedsExample
  - RTCDtlsTransport
  - Reference
---
<p>{{DefaultAPISidebar("WebRTC")}}</p>

<p>The <strong><code>RTCDtlsTransport</code></strong> interface provides access to information about the Datagram Transport Layer Security (<strong>{{Glossary("DTLS")}}</strong>) transport over which a {{domxref("RTCPeerConnection")}}'s {{Glossary("RTP")}} and {{Glossary("RTCP")}} packets are sent and received by its {{domxref("RTCRtpSender")}} and {{domxref("RTCRtpReceiver")}} objects.</p>

<p>A DTLS transport is also used to provide information about {{Glossary("SCTP")}} packets transmitted and received by an connection's <a href="/en-US/docs/Web/API/RTCDataChannel">data channels</a>.</p>

<p>Features of the DTLS transport include the addition of security to the underlying transport; the <code>RTCDtlsTransport</code> interface can be used to obtain information about the underlying transport and the security added to it by the DTLS layer.</p>

<p>{{InheritanceDiagram}}</p>

<div>{{InterfaceOverview("WebRTC")}}</div>

<h2 id="Description">Description</h2>

<h3 id="Allocation_of_DTLS_transports">Allocation of DTLS transports</h3>

<p><code>RTCDtlsTransport</code> objects are created when an app calls either {{domxref("RTCPeerConnection.setLocalDescription", "setLocalDescription()")}} or {{domxref("RTCPeerConnection.setRemoteDescription", "setRemoteDescription()")}}. The number of DTLS transports created and how they're used depends on the bundling mode used when creating the {{domxref("RTCPeerConnection")}}.</p>

<p>Whether bundling is used depends on what the other endpoint is able to negotiate. All browsers support bundling, so when both endpoints are browsers, you can rest assured that bundling will be used.</p>

<p>Some non-browser legacy endpoints, however, may not support bundle. To be able to negotiate with such endpoints (or to exclude them entirely), the {{domxref("RTCConfiguration")}} property {{domxref("RTCConfiguration.bundlePolicy", "bundlePolicy")}} may be provided when creating the connection. The <code>bundlePolicy</code> <a href="/en-US/docs/Web/API/RTCPeerConnection#RTCBundlePolicy_enum">lets you control</a> how to negotiate with these legacy endpoints. The default policy is <code>"balanced"</code>, which provides a balance between performance and compatibility.</p>

<p>For example, to create the connection using the highest level of bundling:</p>

<pre class="brush: js notranslate">const rtcConfig = {
  bundlePolicy: "max-bundle"
};

const pc = new RTCPeerConnection(rtcConfig);
</pre>

<p><a href="https://webrtcstandards.info/sdp-bundle/">Bundling</a> lets you use one <code>RTCDtlsTransport</code> to carry the data for multiple higher-level transports, such as multiple {{domxref("RTCRtpTransceiver")}}s.</p>

<h4 id="When_not_using_BUNDLE">When not using BUNDLE</h4>

<p>When the connection is created without using BUNDLE, each RTP or RTCP component of each {{domxref("RTCRtpTransceiver")}} has its own <code>RTCDtlsTransport</code>; that is, every {{domxref("RTCRtpSender")}} and {{domxref("RTCRtpReceiver")}}, has its own transport, and all {{domxref("RTCDataChannel")}} objects share a transport dedicated to SCTP.</p>

<h4 id="When_using_BUNDLE">When using BUNDLE</h4>

<p>When the connection is using BUNDLE, each <code>RTCDtlsTransport</code> object represents a group of {{domxref("RTCRtpTransceiver")}} objects. If the connection was created using <code>max-compat</code> mode, each transport is responsible for handling all of the communications for a given type of media (audio, video, or data channel). Thus, a connection that has any number of audio and video channels will always have exactly one DTLS transport for audio and one for video communications.</p>

<p>Because transports are established early in the negotiation process, it's likely that it won't be known until after they're created whether or not the remote peer supports bundling or not. For this reason, you'll sometimes see separate transports created at first, one for each track, then see them get bundled up once it's known that bundling is possible. If your code accesses  {{domxref("RTCRtpSender")}}s and/or {{domxref("RTCRtpReceiver")}}s directly, you may encounter situations where they're initially separate, then half or more of them get closed and the senders and receivers updated to refer to the appropriate remaining <code>RTCDtlsTransport</code> objects.</p>

<h3 id="Data_channels">Data channels</h3>

<p>{{domxref("RTCDataChannel")}}s use {{Glossary("SCTP")}} to communicate. All of a peer connection's data channels share a single {{domxref("RTCSctpTransport")}}, found in the connection's {{domxref("RTCPeerConnection.sctp", "sctp")}} property.</p>

<p>You can, in turn, identify the <code>RTCDtlsTransport</code> used to securely encapsulate the data channels' SCTP communications by looking at the <code>RTCSctpTransport</code> object's {{domxref("RTCSctpTransport.transport", "transport")}} property.</p>

<h2 id="Examples">Examples</h2>

<p>This example presents a function, <code>tallySenders()</code>, which iterates over an <code>RTCPeerConnection</code>'s {{domxref("RTCRtpSender")}}s, tallying up how many of them are in various states. The function returns an object containing properties whose values indicate how many of the senders are in each state.</p>

<pre class="brush: js notranslate">let pc = new RTCPeerConnection({ bundlePolicy: "max-bundle" });

/* ... */

function tallySenders(pc) {
  let results = {
    transportMissing: 0,
    connectionPending: 0,
    connected: 0,
    closed: 0,
    failed: 0,
    unknown: 0
  };

  let senderList = pc.getSenders();
  senderList.forEach(sender =&gt; {
    let transport = sender.transport;

    if (!transport) {
      results.transportMissing++;
    } else {
      switch(transport.state) {
        case "new":
        case "connecting":
          results.connectionPending++;
          break;
       case "connected":
          results.connected++;
          break;
       case "closed":
          results.closed++;
          break;
       case "failed":
          results.failed++;
          break;
       default:
          results.unknown++;
          break;
      }
    }
  });
  return results;
}
</pre>

<p>Note that in this code, the <code>new</code> and <code>connecting</code> states are being treated as a single <code>connectionPending</code> status in the returned object.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("WebRTC 1.0", "#dom-rtcdtlstransport", "RTCDtlsTransport")}}</td>
   <td>{{Spec2("WebRTC 1.0")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCDtlsTransport")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("RTCRtpSender.transport")}} and {{domxref("RTCRtpReceiver.transport")}}</li>
 <li>{{DOMxRef("RTCSctpTransport.transport")}}</li>
</ul>
